//////////////////////////////////////////////////////////////////////////
// p[eBN
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
// O[o
//////////////////////////////////////////////////////////////////////////
float4x4 	g_wvp;
float		g_time;
texture 	g_texture;

//////////////////////////////////////////////////////////////////////////
// Tv
//////////////////////////////////////////////////////////////////////////
sampler TextureSampler = 
sampler_state
{
    Texture = <g_texture>;
};

//////////////////////////////////////////////////////////////////////////
// _VF[_[o͗p\
//////////////////////////////////////////////////////////////////////////
struct VS_IN
{
	float3	pos : POSITION;
	float	size : PSIZE;
	float3	dir : TEXCOORD0;
	float	life : TEXCOORD1;
	float	start : TEXCOORD2;
};

struct VS_OUT
{
	float4	pos : POSITION;
	float2	tex : TEXCOORD0;
	float	size : PSIZE;
};

//////////////////////////////////////////////////////////////////////////
// _VF[_[
//
//
//////////////////////////////////////////////////////////////////////////
VS_OUT VS(VS_IN In)
{
	VS_OUT Out = (VS_OUT)0;
	
	Out.size = In.size;					// ̂܂܂̃TCY
	
	float time = g_time - In.start;		// Ԃ̌v
	
	time = fmod( time, In.life);		// Aj[V̌JԂl
	
	float3 accel = float3( 0.0f, -9.8f, 0.0f );	// d
	
	// |CgXvCg̈ʒuvZ
	float3 pos;
	pos = In.pos + In.dir * time + 0.5f * accel * time * time;
	
	Out.pos = mul( float4( pos, 1.0f ), g_wvp );	// Wϊ
	
	Out.tex = 0.0f;
	
	return Out;
}

//////////////////////////////////////////////////////////////////////////
// sNZVF[_[
//
//
//////////////////////////////////////////////////////////////////////////
float4 PS( float2 tex : TEXCOORD0 ) : COLOR
{
	float4 Color;
	
	Color = tex2D( TextureSampler, tex );		// F̏o
	
	return Color;
}

//////////////////////////////////////////////////////////////////////////
// eNjbN
//////////////////////////////////////////////////////////////////////////
// Z
technique Particle
{
	pass P0
	{	
		POINTSPRITEENABLE = TRUE;
		POINTSCALEENABLE = TRUE;
		POINTSIZE_MIN = 0.0;
		POINTSCALE_A = 0.0;
		POINTSCALE_B = 0.0;
		POINTSCALE_C = 1.0;

        ALPHABLENDENABLE = TRUE;
	    SRCBLEND     = ONE;
	    DESTBLEND    = ONE;	    
	    ZWRITEENABLE = FALSE;

		VertexShader = compile vs_2_0 VS();
		PixelShader = compile ps_2_0 PS();
	} 
}

// ZȂ
technique Particle2
{
	pass P0
	{	
		POINTSPRITEENABLE = TRUE;
		POINTSCALEENABLE = TRUE;
		POINTSIZE_MIN = 0.0;
		POINTSCALE_A = 0.0;
		POINTSCALE_B = 0.0;
		POINTSCALE_C = 1.0;

        //ALPHABLENDENABLE = TRUE;
	    //SRCBLEND     = ONE;
	    //DESTBLEND    = ONE;	    
	    ZWRITEENABLE = FALSE;

		VertexShader = compile vs_2_0 VS();
		PixelShader = compile ps_2_0 PS();
	} 
}