//////////////////////////////////////////////////////
// w
//////////////////////////////////////////////////////

float4x4 g_mWVP;
texture g_EnvTexture;

// Tv
sampler EnvSampler = sampler_state
{
	Texture = <g_EnvTexture>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
	AddressU=CLAMP;
	AddressV=CLAMP;
};

// \
struct VS_OUT
{
	float4 Pos : POSITION;
	float2 EnvUV : TEXCOORD0;
};

// _VF[_[
void StealthVS( float4 in_pos : POSITION, float3 in_normal : NORMAL, out float4 out_pos : POSITION, out float2 EnvUV : TEXCOORD0 )
{
	//VS_OUT out = (VS_OUT)0;

	out_pos = mul( in_pos, g_mWVP );	// _ϊ
	
	// -----------------------------------------------
	// wieNX`QƂ邽߂̃eNX`W
	// @xNg[hr[ˉeϊ
	float3 wvp_normal = normalize( mul(in_normal, (float3x3)g_mWVP) );
	// eNX`W̌vZ
	EnvUV = (out_pos.xy + wvp_normal.xy * 10.0f) / out_pos.w * float2(0.5f, -0.5f)+0.5f;

	//return VS_OUT;
}

// sNZVF[_[
float4 StealthPS( float2 EnvUV : TEXCOORD0 ) : COLOR
{
	return tex2D( EnvSampler, EnvUV );
}

// eNjbN
technique Stealth
{
	pass P0
	{	
		VertexShader = compile vs_2_0 StealthVS();
		PixelShader = compile ps_2_0 StealthPS();
	}
}
