//////////////////////////////////////////////////////////////////////////////////////////
// gD[VF[_[vO
// X^eBbNbV
// XLbV̓oO?
// ֊sbVɂĂ͂Ĉ
// ֊s̏õASY̕ύX邩
// ͎xNgƒ_W̓ς0`0.25Ȃ֊s
// ʂ̃ASY͕\ʃJObVgA}eAɂ
// ʃJObVɍ킹ƏoH
//////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// O[o
/////////////////////////////////////////////////////////////////////////////
float4x4 g_mProj;	// Es
float4x4 g_mView;	// _s
float4x4 g_mWorld;	// [hϊs
float4x4 g_mNormalWorld;	// [hϊs(@pAgsȂ)
//float4x4 g_mWvp;	// [hr[ˉes(gpĂȂ)
//float4 g_Color;		// (gpĂȂ)
float3 g_LightPos;	// CgxNg
float3 g_EyePos;	// JW
float4 g_Diffuse;
texture g_DecalTexture;	// fJ[
texture g_ShadeTexture;	// gD[(ZW)
texture g_LineTexture;	// gD[(֊s)

///////////////////////////////////////////////////////////////////////////////
// Tv
///////////////////////////////////////////////////////////////////////////////
// fJ[eNX`
sampler DecalSampler = sampler_state
{
	Texture = <g_DecalTexture>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = Clamp;
	AddressV = Clamp;
};

// ZWeNX`
sampler ShadeSampler = sampler_state
{
	Texture = <g_ShadeTexture>;
};

// ֊seNX`
sampler LineSampler = sampler_state
{
	Texture = <g_LineTexture>;
};

////////////////////////////////////////////////////////////////////////////////////////////////
// \̐錾
////////////////////////////////////////////////////////////////////////////////////////////////
// eNX`L
struct VS_OUT_PS_IN
{
	float4 Position : POSITION;
	float2 Decal : TEXCOORD;
	float Line : TEXCOORD1;
	float Shade : TEXCOORD2;
};

// eNX`
struct VS_OUT_PS_IN2
{
	float4 Position : POSITION;
	float4 Color : COLOR;
	float Line : TEXCOORD;
	float Shade : TEXCOORD1;
};

////////////////////////////////////////////////////////////////////////////////////////////////
// o[ebNXEVF[_[
////////////////////////////////////////////////////////////////////////////////////////////////
// eNX`LgD[VF[_[vO
VS_OUT_PS_IN VS(float3 Position : POSITION, float3 Normal : NORMAL, float4 Color : COLOR, float2 TexCoord : TEXCOORD)
{
	// o̓f[^
	VS_OUT_PS_IN Out = (VS_OUT_PS_IN)0;

	Out.Position = mul(float4(Position, 1), g_mWorld);		// ʒuxNg[J烏[hɕϊ
	Normal = mul(Normal, (float3x3)g_mNormalWorld);					// @[J烏[hɕϊ
	normalize(Normal);// @𐳋K(gsgĂꍇɗL)
	float3 lightVec = normalize(g_LightPos - Out.Position);	// bV̈ʒu烉Cg܂ł̃xNg߂ĐK
	float3 eyeVec = normalize(g_EyePos - Out.Position);		// bV̈ʒu王_܂ł̃xNg߂ĐK
	
	Out.Shade = max(dot(Normal, lightVec), 0);			// @ƃCgxNg̓ς0̑傫ق
	Out.Line = max(dot(Normal, eyeVec), 0);				// @Ǝ_xNg̓ς0̑傫ق
														// bV̗֊st߂͎xNgɑ΂萂Ȃ̂ŁAς0ɋ߂Ȃ
	Out.Position = mul(Out.Position, mul(g_mView, g_mProj));// ˉeԂɕϊ([hr[ˉeϊ)
	Out.Decal = TexCoord;

	return Out;
}

// eNX`gD[VF[_[vO
VS_OUT_PS_IN2 VS2(float3 Position : POSITION, float3 Normal : NORMAL, float4 Color : COLOR)
{
	// o̓f[^
	VS_OUT_PS_IN2 Out = (VS_OUT_PS_IN2)0;

	Out.Position = mul(float4(Position, 1), g_mWorld);		// ʒuxNg[J烏[hɕϊ
	Normal = mul(Normal, (float3x3)g_mWorld);				// @[J烏[hɕϊ
	normalize(Normal);// @𐳋K(gsgĂꍇɗL)
	float3 lightVec = normalize(g_LightPos - Out.Position);	// bV̈ʒu烉Cg܂ł̃xNg߂ĐK
	float3 eyeVec = normalize(g_EyePos - Out.Position);		// bV̈ʒu王_܂ł̃xNg߂ĐK
	
	Out.Shade = max(dot(Normal, lightVec), 0);			// @ƃCgxNg̓ς0̑傫ق
	Out.Line = max(dot(Normal, eyeVec), 0);				// @Ǝ_xNg̓ς0̑傫ق
														// bV̗֊st߂͎xNgɑ΂萂Ȃ̂ŁAς0ɋ߂Ȃ
	Out.Position = mul(Out.Position, mul(g_mView, g_mProj));// ˉeԂɕϊ([hr[ˉeϊ)
	Out.Color = Color;

	return Out;
}

////////////////////////////////////////////////////////////////////////////////////////////////
// sNZEVF[_[
////////////////////////////////////////////////////////////////////////////////////////////////
// eNX`LgD[VF[_[vO
float4 PS( VS_OUT_PS_IN In) : COLOR
{
	float4 Color;

	Color = tex2D(DecalSampler, In.Decal) * g_Diffuse * tex1D(LineSampler, In.Line) * tex1D(ShadeSampler, In.Shade);

	return Color;
}

// eNX`gD[VF[_[vO
float4 PS2( VS_OUT_PS_IN2 In) : COLOR
{
	float4 Color;

	Color = g_Diffuse * tex1D(LineSampler, In.Line) * tex1D(ShadeSampler, In.Shade);

	return Color;
}

////////////////////////////////////////////////////////////////////////////////////////////////
// eNjbN
////////////////////////////////////////////////////////////////////////////////////////////////
// eNX`LgD[VF[fBOeNjbN
technique ToonShading
{
	// eNX`L
	pass P0
	{
		//ZEnable = TRUE;
		
		Sampler[0] = (LineSampler);
		Sampler[1] = (ShadeSampler);

		VertexShader = compile vs_2_0 VS();
		PixelShader = compile ps_2_0 PS();
	}
	
	// eNX`
	pass P1
	{
		//ZEnable = TRUE;
		
		Sampler[0] = (LineSampler);
		Sampler[1] = (ShadeSampler);

		VertexShader = compile vs_2_0 VS2();
		PixelShader = compile ps_2_0 PS2();
	}
}

// eNX`gD[VF[fBOeNjbN(gȂ)
technique ToonShading2
{
	pass Toon
	{
		//ZEnable = TRUE;
		
		Sampler[0] = (LineSampler);
		Sampler[1] = (ShadeSampler);

		VertexShader = compile vs_2_0 VS2();
		PixelShader = compile ps_2_0 PS2();
	}
}
